--------------------------------------------------
-- TimingGen.vhd
-- Timing Generater
-- by Toshio Iwata at digitalfilter.com 2009/05/06

library IEEE;
  use IEEE.std_logic_1164.all;
  use IEEE.std_logic_arith.all;

entity TimingGen is
   Port (
          RST_N : In std_logic;
          MCLK : In std_logic;
          ALRCLK : Out std_logic;
          ABCLK : Out std_logic;
          AMCLK : Out std_logic ); 
end TimingGen;

architecture RTL of TimingGen is

  signal counter512 : unsigned(8 downto 0);
--  signal WR_N : std_logic;

begin
-------------------------------------------------------------------
gen_counter512 : process( RST_N, MCLK )
begin
  if( RST_N = '0' ) then
    counter512  <= (others => '0');
  elsif( MCLK'event and MCLK = '1' ) then
    counter512 <= counter512 + 1; -- up counter
  end if;
end process;

-------------------------------------------------------------------
  AMCLK <= counter512(0);
  ABCLK <= counter512(2);
  ALRCLK <= counter512(8);

end;
